<?php

function bytes_to_unsigned_integer($H, $L)
{
	    $value = (($H * 256) + $L);
	    return $value;
}

function bytes_to_unsigned_long_integer($HHH, $HH, $HL, $LH, $LL){
	$value = ($HHH*4294967296) + ($HH*16777216) + ($HL*65536) + ($LH*256) + ($LL);
	return $value;
}

function restore_pack($path, $filename)
{
if ( ! is_dir("$path"))
mkdir("$path");

$fh = fopen($filename, 'rb') or die("can't open file");

//Skip compression dictionary size (not supported in php)
$contents = fread($fh, 1);

$size = filesize($filename);
$curs = 0 ;

while ( $curs < $size )
{
//Get the type
$contents = fread($fh, 1);
$type = ord($contents[0]);
$curs += 1;

if ( $type == 0 || $type == 2)
{
//Get name lenght
$contents = fread($fh, 2);
$curs += 2;

$name_len = bytes_to_unsigned_integer(ord($contents[0]), ord($contents[1]));
$name = fread($fh, $name_len);
$curs +=  $name_len;

$dirs = explode("/", $name);
$dir = "";
for ($i = 0; $i< count($dirs)-1; $i++)
{
$dir .= $dirs[$i] ."/";
if ( ! is_dir("$path/$dir"))
mkdir("$path/$dir");
}

$contents = fread($fh, 5);
$curs += 5;

$content_lenght =  bytes_to_unsigned_long_integer( ord($contents[0]), ord($contents[1]), ord($contents[2]), ord($contents[3]), ord($contents[4]));

$fhw = fopen("$path/$name", 'wb') or die("can't open file");

$read_data = 0;
$buffer_size = 10000;

while ($read_data < $content_lenght)
{
if ($buffer_size > ( $content_lenght - $read_data) )
$buffer_size = $content_lenght - $read_data;
$content = fread($fh, $buffer_size);
$curs +=  $buffer_size;
fwrite($fhw, $content);
$read_data += $buffer_size;
}

fclose($fhw);
}


if ( $type == 1 )
{
//Get name lenght
$contents = fread($fh, 2);
$curs += 2;
$name_len = bytes_to_unsigned_integer(ord($contents[0]), ord($contents[1]));
//echo "<br>Name Len: $name_len";
$name = fread($fh, $name_len);
$curs +=  $name_len;

$dirs = explode("/", $name);
$dir = "";
for ($i = 0; $i< count($dirs)-1; $i++)
{
$dir .= $dirs[$i] ."/";
if ( ! is_dir("$path/$dir"))
mkdir("$path/$dir");
}
if ( ! is_dir("$path/$name"))
mkdir("$path/$name");
}
}
fclose($fh);
}

restore_pack('destination', 'FileToRestore.pack');
?>
